"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const allFiles = new Set();
const allFolders = new Set();
/** Generate list of files in a directory. */
function walk(folder, ignored = []) {
    if (Array.isArray(folder)) {
        for (const path of folder)
            walk(path, ignored);
    }
    else {
        const files = fs_1.default.readdirSync(folder);
        for (const file of files) {
            const path = path_1.default.resolve(folder, file).replace(/\\/g, '/');
            if (!fs_1.default.existsSync(path) || ignored.some(pattern => pattern.test(path)))
                continue;
            allFolders.add(folder.replace(/\\/g, '/'));
            if (fs_1.default.lstatSync(path).isDirectory()) {
                allFolders.add(path);
                walk(path, ignored);
                continue;
            }
            allFiles.add(path);
        }
    }
    return {
        files: [...allFiles],
        folders: [...allFolders],
    };
}
exports.default = walk;
